package com.synergy.wmc.wmc_personalized_plugin;

import android.Manifest;
import android.content.Context;
import android.content.pm.PackageManager;
import android.net.ConnectivityManager;
import android.net.Network;
import android.net.NetworkCapabilities;
import android.net.NetworkInfo;
import android.os.Build;
import androidx.core.app.ActivityCompat;
import android.telephony.TelephonyManager;
import android.text.TextUtils;
import android.util.Log;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.jaredrummler.android.device.DeviceName;

import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URL;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map; 
import java.util.UUID;

import cz.msebera.android.httpclient.HttpHost;
import cz.msebera.android.httpclient.HttpResponse;
import cz.msebera.android.httpclient.NameValuePair;
import cz.msebera.android.httpclient.auth.AuthScope;
import cz.msebera.android.httpclient.auth.UsernamePasswordCredentials;
import cz.msebera.android.httpclient.client.HttpClient;
import cz.msebera.android.httpclient.client.HttpResponseException;
import cz.msebera.android.httpclient.client.entity.UrlEncodedFormEntity;
import cz.msebera.android.httpclient.client.methods.HttpDelete;
import cz.msebera.android.httpclient.client.methods.HttpGet;
import cz.msebera.android.httpclient.client.methods.HttpPost;
import cz.msebera.android.httpclient.client.methods.HttpPut;
import cz.msebera.android.httpclient.client.utils.URIBuilder;
import cz.msebera.android.httpclient.conn.params.ConnRoutePNames;
import cz.msebera.android.httpclient.impl.client.DefaultHttpClient;
import cz.msebera.android.httpclient.entity.StringEntity;
import cz.msebera.android.httpclient.message.BasicNameValuePair;
import io.flutter.plugin.common.MethodChannel;
import okhttp3.Credentials;


public class ApiWmcModule {

    private static final String E_TOKEN_ERROR = "E_TOKEN_ERROR";
    private static final String E_HTTP_ERROR = "HttpResponseException";
    private static final String E_HOST_ERROR = "HttpHostException";
    private static String mcc = "";
    private static String mnc = "";
    private static String unique = "";
    private static final String E_SESSION_ERROR = "E_TOKEN_ERROR";
    private static final String E_REQUEST_ERROR = "E_TOKEN_ERROR";
    private static final String UrlWmc = "https://api.worldmobileconnection.com/v2/";
    private static String device_name = "";
    private static String device_os = "";
    private static String appid = "";
    private static String app_Version = "";
    private static String language = "";
    private static String network_type= "";

    public static void initialize (Context context ,String apikey, ResultInitListener listener) {
        try {
            // TODO Logic to get token from proxy
            // Return a JSON with token: {token: '32978423984khsdfkhsakdf'}
            Log.e("ApiWMC/getToken","api key "+apikey);

            String token =  getToken(apikey);

            Log.e("ApiWMC/getToken","context "+context);

            if(token != null){
                new SessionManager(context).setApiKey(apikey);
                listener.onSuccess("Inicializacion correcta");
            }

        }  catch (Exception e) {
            Log.e("ApiWMC/getToken","error",e);
            // Return real error
            listener.onError(E_TOKEN_ERROR,"E_TOKEN_ERROR", new Exception("Error get token"));
        }

    }

    public static String getToken(String apikey){
        try{
            HttpClient client = new DefaultHttpClient();
            HttpPost post = new HttpPost(UrlWmc+"gettoken");
            List<NameValuePair> urlParameters = new ArrayList<NameValuePair>();
            urlParameters.add(new BasicNameValuePair("apikey", apikey));
            post.setEntity(new UrlEncodedFormEntity(urlParameters));

            HttpResponse response = client.execute(post);

            BufferedReader rd = new BufferedReader(
                    new InputStreamReader(response.getEntity().getContent()));

            StringBuffer result = new StringBuffer();
            String line = "";
            while ((line = rd.readLine()) != null) {
                result.append(line);
            }

            Log.e("ApiWMC/getToken","token react "+result.toString());
            Log.e("ApiWMC/getTokenCODE", response.getStatusLine().getStatusCode() + "");
            if(response.getStatusLine().getStatusCode() != 409 //Cuenta inactiva
                    && response.getStatusLine().getStatusCode() != 412 // Cuenta inactiva
                    && response.getStatusLine().getStatusCode() != 503 // mantenimiento
                    && response.getStatusLine().getStatusCode() != 407){ //
                Gson gson = new Gson();
                HashMap<String, String> map = gson.fromJson(result.toString(), HashMap.class);

                Log.e("ApiWMC/getToken","convert "+map);
                return  map.get("Token");
            }
        }catch (HttpResponseException ht){
            //promise.reject(E_HTTP_ERROR,String.valueOf(ht.getStatusCode()));
        } catch (Exception e) {
            Log.e("ApiWMC/getToken","error",e);
            // Return real error
        }
        return null;
    }

    /**
     * Obtiene una session valida otorgada por WMC
     * @param token token valido
     */
    public static Session  getSession (Context context ,String token) {
        try {
            // TODO Logic to get session from proxy
            HttpClient client = new DefaultHttpClient();
            //HttpPost post = new HttpPost(UrlWmc+"getuser");
            Log.e("ApiWMC/getSession","token "+token);

            if(token == null) {
                SessionManager sessionManager = new SessionManager(context);
                String apikey = sessionManager.getApiKey();
                String token1 = getToken(apikey);
                Log.e("ApiWMC/getToken","token react "+token1);
                token = token1;
            }

            //Inicializa valores de mcc, mnc y unique
            getInfoSim(context);
            setDetailDevice();
            //BEGIN Tests simulator
            if(mcc == null || mcc.isEmpty()){
                mcc = "214";
            }
            if(mnc == null || mnc.isEmpty()){
                mnc = "07";
            }
            if(unique == null || unique.isEmpty()){
                unique = "josem";
            }
/*
            if(latitude == null || latitude.isEmpty()){
                latitude = "41.3891";
            }
            if(longitude == null || longitude.isEmpty()){
                longitude = "2.1611";
            }
*/
            //END Tests simulator

            String connection = getTransport(context);

            Log.e("ApiWMC/getSession","mcc "+mcc);
            Log.e("ApiWMC/getSession","mnc "+mnc);
            Log.e("ApiWMC/getSession","uniqid "+unique);
            Log.e("ApiWMC/getSession","transport "+connection);
            Log.e("ApiWMC/getSession","device_name "+device_name);
            Log.e("ApiWMC/getSession","device_os "+device_os);
            Log.e("ApiWMC/getSession","appid "+appid);
            Log.e("ApiWMC/getSession","app_Version "+app_Version);
            Log.e("ApiWMC/getSession","app_Version "+language);
            Log.e("ApiWMC/getSession","network_type "+network_type);
            /*Log.e("ApiWMC/getSession","latitud "+latitud);
            Log.e("ApiWMC/getSession","longitud "+longitud);*/


            List<NameValuePair> urlParameters = new ArrayList<NameValuePair>();
            urlParameters.add(new BasicNameValuePair("token", token));
            urlParameters.add(new BasicNameValuePair("mcc", mcc));
            urlParameters.add(new BasicNameValuePair("mnc", mnc));
            urlParameters.add(new BasicNameValuePair("uniqid", unique));
            urlParameters.add(new BasicNameValuePair("transport",connection));
            urlParameters.add(new BasicNameValuePair("device_name",device_name));
            urlParameters.add(new BasicNameValuePair("device_os", device_os));
            urlParameters.add(new BasicNameValuePair("appid", appid));
            urlParameters.add(new BasicNameValuePair("app_Version",app_Version));
            /*urlParameters.add(new BasicNameValuePair("latitude",latitud + ""));
            urlParameters.add(new BasicNameValuePair("longitude",longitud + ""));*/
            urlParameters.add(new BasicNameValuePair("language",language));
            urlParameters.add(new BasicNameValuePair("network_type",network_type));
            HttpPost post = new HttpPost(UrlWmc+"getuser");

            post.setEntity(new UrlEncodedFormEntity(urlParameters));

            Log.e("ApiWMC/getSession",post.getURI().toString());



            HttpResponse response = client.execute(post);


            BufferedReader rd = new BufferedReader(
                    new InputStreamReader(response.getEntity().getContent()));

            StringBuffer result = new StringBuffer();
            String line = "";
            while ((line = rd.readLine()) != null) {
                result.append(line);
            }

            Log.e("ApiWMC/getSession",result.toString());

            Gson gson = new Gson();

            Session obj = gson.fromJson(result.toString(), Session.class);
            obj.setTransport(Session.Transport.valueOf(connection));
            obj.setCreated(new Date().getTime());

            new SessionManager(context).setSession(obj);
            return  obj;

        } catch (HttpResponseException ht){
        } catch (Exception e) {
            // Return real error
            Log.e("ApiWMC/getSession","error",e);
        }
        return null;
    }

    public static void connectionData(Context context,ResultRequestListener listener){
        String connection = getTransport(context);
        getInfoSim(context); 

        
        if(mcc == null || mcc.isEmpty()){
            mcc = "error";
        }

        if(mnc == null || mnc.isEmpty()){
            mnc = "error";
        }

        Map<String, String> res = new HashMap<String, String>();
        res.put("mcc",mcc);
        res.put("mnc",mnc);
        res.put("transport",connection);
        listener.onSuccess(res);
    }


    public static void request(Context context,String uri,String method,Map<String,String> options, Map<String,String> data,ResultRequestListener listener){

        Session.Transport transport = Session.Transport.valueOf(getTransport(context));
        SessionManager sessionManager = new SessionManager(context);
        Session session = sessionManager.getSession(transport);

        if(session == null){
            String apikey = sessionManager.getApiKey();
            String token = getToken(apikey);
            Log.e("ApiWMC/getToken","token react "+token);
            session = getSession(context,token);
            if(session == null){
                listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR, new Exception("Error get Session"));
            }

        }

        if(method.equals("GET")){
            get(uri,session,options,data,listener);
        }else if(method.equals("DELETE")){
            delete(uri,session,options,data,listener);
        }
    }


    public static void getResource(Context context,String uri, ResultRequestDataListener listener){

        Session.Transport transport = Session.Transport.valueOf(getTransport(context));
        SessionManager sessionManager = new SessionManager(context);
        Session sesion = sessionManager.getSession(transport);

        if(sesion == null){
            String apikey = sessionManager.getApiKey();
            String token = getToken(apikey);
            Log.e("ApiWMC/getToken","token react "+token);
            sesion = getSession(context,token);
            if(sesion == null){
                listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR, new Exception("Error get Session"));
            }

        }


        try {
            // conversion de map to object
            DefaultHttpClient httpclient = new DefaultHttpClient();
            HttpGet get = new HttpGet(uri);

            if(sesion != null){ //proxy
                //configuracion de cliente con Proxy
                httpclient = setupClient(sesion);
                Log.e("ApiWMC/get","session react "+sesion);
                String credential = Credentials.basic(sesion.getUsername(), sesion.getPassword());
                get.setHeader("sessionid",sesion.getSessionid());
                get.setHeader("Proxy-Authorization",credential);
            }


            Log.e("ApiWMC/get","Url react "+uri);
            Log.e("ApiWMC/get","client "+httpclient.toString());
            Log.e("ApiWMC/get","token react "+sesion);

            URI uriRequest = new URIBuilder(get.getURI()).build();

            get.setURI(uriRequest);

            HttpResponse response = httpclient.execute(get);

            if (response.getStatusLine().getStatusCode() == 200){
                try{
                    ByteArrayOutputStream baos = new ByteArrayOutputStream();
                    response.getEntity().writeTo(baos);
                    byte[] bytes = baos.toByteArray();

                    listener.onSuccess(bytes);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }else{
                listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR, new Exception("Error request responseCode:"+response.getStatusLine().getStatusCode()));
            }
        } catch (HttpResponseException ht){
            listener.onError(E_HTTP_ERROR,String.valueOf(ht.getStatusCode()),ht);
        } catch (MalformedURLException mue){
            listener.onError(E_HOST_ERROR,E_HTTP_ERROR,mue);
        } catch (UnknownHostException ht){
            listener.onError(E_HOST_ERROR,E_HTTP_ERROR,ht);
        } catch (Exception e) {
            // Return real error
            Log.e("ApiWMC/post","error",e);
            listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR, e);
        }


    }

    /**
     * Método que ejecuta un petición de tipo POST
     * @param uri Url a realizar el request
     * @param options
     * @param data
     * @param listener
     */

    public static void post(Context context,String uri, Map<String,String> options, String data, ResultRequestListener listener) {

        Session.Transport transport = Session.Transport.valueOf(getTransport(context));
        SessionManager sessionManager = new SessionManager(context);
        Session sesion = sessionManager.getSession(transport);

        if(sesion == null){
            String apikey = sessionManager.getApiKey();
            String token = getToken(apikey);
            Log.e("ApiWMC/getToken","token react "+token);
            sesion = getSession(context,token);
            if(sesion == null){
                listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR, new Exception("Error get Session"));
            }

        }

        try {
            // conversion de map to object
            Gson gson=new GsonBuilder().create();

            //configuracion de cliente con Proxy
            DefaultHttpClient httpclient = setupClient(sesion);


            HttpPost post = new HttpPost(uri);
            post.setHeader("sessionid",sesion.getSessionid());
            for (Map.Entry<String, String> entry : options.entrySet()) {
                post.setHeader(entry.getKey(),entry.getValue().toString());
            }
            //post.setHeader("Proxy-Authorization",);

            StringEntity params =new StringEntity(data);
            post.setEntity(params);

            HttpResponse response = httpclient.execute(post);

            if(response.getStatusLine().getStatusCode() != 409 //Cuenta inactiva
                    && response.getStatusLine().getStatusCode() != 412 // Cuenta inactiva
                    && response.getStatusLine().getStatusCode() != 503 // mantenimiento
                    && response.getStatusLine().getStatusCode() != 407){ //
                BufferedReader rd = new BufferedReader(
                        new InputStreamReader(response.getEntity().getContent()));

                StringBuffer result = new StringBuffer();
                String line = "";
                while ((line = rd.readLine()) != null) {
                    result.append(line);
                }

                System.out.println(result.toString());

                JSONObject jsonObject = new JSONObject(result.toString());

                Map<String, String> res = new HashMap<String, String>();
                res.put("status_code",String.valueOf(response.getStatusLine().getStatusCode()));
                res.put("data",result.toString());

                listener.onSuccess(res);
            }else{
                listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR, new Exception("Error request responseCode:"+response.getStatusLine().getStatusCode()));
            }


        } catch (HttpResponseException ht){
            listener.onError(E_HTTP_ERROR,String.valueOf(ht.getStatusCode()),ht);
        } catch (MalformedURLException mue){
            listener.onError(E_HOST_ERROR,E_HTTP_ERROR,mue);
        } catch (UnknownHostException ht){
            listener.onError(E_HOST_ERROR,E_HTTP_ERROR,ht);
        } catch (Exception e) {
            // Return real error
            Log.e("ApiWMC/post","error",e);
            listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR,e);
        }
    }

    /**
     * Método que ejecuta un petición de tipo GET
     * @param uri Url a realizar el request
     * @param sesion objecto que contiene la información de sesion para conexión con el proxy
     * @param optionsMap
     * @param parameters
     * @param listener
     */

    public static void get(String uri, Session sesion, Map<String,String> optionsMap, Map<String,String> parameters, ResultRequestListener listener) {
        try {
            // conversion de map to object
            DefaultHttpClient httpclient = new DefaultHttpClient();
            HttpGet get = new HttpGet(uri);

            if(sesion != null){ //proxy
                //configuracion de cliente con Proxy
                httpclient = setupClient(sesion);
                Log.e("ApiWMC/get","session react "+sesion);
                String credential = Credentials.basic(sesion.getUsername(), sesion.getPassword());
                get.setHeader("sessionid",sesion.getSessionid());
                get.setHeader("Proxy-Authorization",credential);
            }


            Log.e("ApiWMC/get","token react "+uri);
            Log.e("ApiWMC/get","client "+httpclient.toString());
            Log.e("ApiWMC/get","token react "+sesion);
            Log.e("ApiWMC/get","token react "+optionsMap);
            Log.e("ApiWMC/get","token react "+parameters);

            for (Map.Entry<String, String> entry : optionsMap.entrySet()) {
                get.setHeader(entry.getKey(),entry.getValue().toString());
            }
            Log.e("ApiWMC/get","header "+get.getAllHeaders());


            //post.setHeader("Proxy-Authorization",);

            //Map<String, Object> parameters = MapUtil.toMap(data);
            List<NameValuePair> urlParameters = new ArrayList<NameValuePair>();
            for (Map.Entry<String, String> entry : parameters.entrySet()) {

                urlParameters.add(new BasicNameValuePair(entry.getKey(), entry.getValue().toString()));
            }

            URI uriRequest = new URIBuilder(get.getURI()).addParameters(urlParameters).build();

            get.setURI(uriRequest);

            HttpResponse response = httpclient.execute(get);

            if(response.getStatusLine().getStatusCode() != 409 //Cuenta inactiva
                    && response.getStatusLine().getStatusCode() != 412 // Cuenta inactiva
                    && response.getStatusLine().getStatusCode() != 503 // mantenimiento
                    && response.getStatusLine().getStatusCode() != 407){ //
                BufferedReader rd = new BufferedReader(
                        new InputStreamReader(response.getEntity().getContent()));

                StringBuffer result = new StringBuffer();
                String line = "";
                while ((line = rd.readLine()) != null) {
                    result.append(line);
                }

                Log.e("ApiWMC/get ",result.toString());
                Log.e("ApiWMC/getCODEORIGINAL", response.getStatusLine().getStatusCode() + "");

                Map<String, String> res = new HashMap<String, String>();
                res.put("status_code",String.valueOf(response.getStatusLine().getStatusCode()));
                res.put("data",result.toString());

                listener.onSuccess(res);

            }else{
                listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR, new Exception("Error request responseCode:"+response.getStatusLine().getStatusCode()));
            }
        } catch (HttpResponseException ht){
            listener.onError(E_HTTP_ERROR,String.valueOf(ht.getStatusCode()),ht);
        } catch (MalformedURLException mue){
            listener.onError(E_HOST_ERROR,E_HTTP_ERROR,mue);
        } catch (UnknownHostException ht){
            listener.onError(E_HOST_ERROR,E_HTTP_ERROR,ht);
        } catch (Exception e) {
            // Return real error
            Log.e("ApiWMC/post","error",e);
            listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR, e);
        }
    }

     /**
     * Método que ejecuta un petición de tipo PUT
     * @param uri Url a realizar el request
     * @param options
     * @param data
     * @param listener
     */

    public static void put(Context context,String uri, Map<String,String> options, String data, ResultRequestListener listener) {
        Session.Transport transport = Session.Transport.valueOf(getTransport(context));
        SessionManager sessionManager = new SessionManager(context);
        Session sesion = sessionManager.getSession(transport);

        if(sesion == null){
            String apikey = sessionManager.getApiKey();
            String token = getToken(apikey);
            Log.e("ApiWMC/getToken","token react "+token);
            sesion = getSession(context,token);
            if(sesion == null){
                listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR, new Exception("Error get Session"));
            }

        }

        try {
            // conversion de map to object
            Gson gson=new GsonBuilder().create();

            //configuracion de cliente con Proxy
            DefaultHttpClient httpclient = setupClient(sesion);


            HttpPut put = new HttpPut(uri);
            put.setHeader("sessionid",sesion.getSessionid());
            for (Map.Entry<String, String> entry : options.entrySet()) {
                put.setHeader(entry.getKey(),entry.getValue().toString());
            }
            //post.setHeader("Proxy-Authorization",);

            StringEntity params =new StringEntity(data);
            put.setEntity(params);

            HttpResponse response = httpclient.execute(put);

            if(response.getStatusLine().getStatusCode() != 409 //Cuenta inactiva
                    && response.getStatusLine().getStatusCode() != 412 // Cuenta inactiva
                    && response.getStatusLine().getStatusCode() != 503 // mantenimiento
                    && response.getStatusLine().getStatusCode() != 407){ //
                BufferedReader rd = new BufferedReader(
                        new InputStreamReader(response.getEntity().getContent()));

                StringBuffer result = new StringBuffer();
                String line = "";
                while ((line = rd.readLine()) != null) {
                    result.append(line);
                }

                System.out.println(result.toString());

                JSONObject jsonObject = new JSONObject(result.toString());
                Map<String, String> res = new HashMap<String, String>();
                res.put("status_code",String.valueOf(response.getStatusLine().getStatusCode()));
                res.put("data",result.toString());

                listener.onSuccess(res);
            }else{
                listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR, new Exception("Error request responseCode:"+response.getStatusLine().getStatusCode()));
            }


        } catch (HttpResponseException ht){
            listener.onError(E_HTTP_ERROR,String.valueOf(ht.getStatusCode()),ht);
        } catch (MalformedURLException mue){
            listener.onError(E_HOST_ERROR,E_HTTP_ERROR,mue);
        } catch (UnknownHostException ht){
            listener.onError(E_HOST_ERROR,E_HTTP_ERROR,ht);
        } catch (Exception e) {
            // Return real error
            Log.e("ApiWMC/post","error",e);
            listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR,e);
        }
    }

     /**
     * Método que ejecuta un petición de tipo POST
     * @param uri Url a realizar el request
     * @param sesion objecto que contiene la información de sesion para conexión con el proxy
     * @param options
     * @param parameters
     * @param listener
     */

    public static void delete(String uri, Session sesion, Map<String,String> options, Map<String,String> parameters, ResultRequestListener listener) {
        try {
            // conversion de map to object
            Gson gson=new GsonBuilder().create();

            //configuracion de cliente con Proxy
            DefaultHttpClient httpclient = setupClient(sesion);
            HttpDeleteWithBody delete = new HttpDeleteWithBody(uri);
            delete.setHeader("sessionid",sesion.getSessionid());
            for (Map.Entry<String, String> entry : options.entrySet()) {
                delete.setHeader(entry.getKey(),entry.getValue().toString());
            }
            //post.setHeader("Proxy-Authorization",);

            List<NameValuePair> urlParameters = new ArrayList<NameValuePair>();

            for (Map.Entry<String, String> entry : parameters.entrySet()) {
                urlParameters.add(new BasicNameValuePair(entry.getKey(), entry.getValue().toString()));
            }

            delete.setEntity(new UrlEncodedFormEntity(urlParameters));

            HttpResponse response = httpclient.execute(delete);

            if(response.getStatusLine().getStatusCode() != 409 //Cuenta inactiva
                    && response.getStatusLine().getStatusCode() != 412 // Cuenta inactiva
                    && response.getStatusLine().getStatusCode() != 503 // mantenimiento
                    && response.getStatusLine().getStatusCode() != 407){ //
                BufferedReader rd = new BufferedReader(
                        new InputStreamReader(response.getEntity().getContent()));

                StringBuffer result = new StringBuffer();
                String line = "";
                while ((line = rd.readLine()) != null) {
                    result.append(line);
                }

                System.out.println(result.toString());

                JSONObject jsonObject = new JSONObject(result.toString());

                Map<String, String> res = new HashMap<String, String>();
                res.put("status_code",String.valueOf(response.getStatusLine().getStatusCode()));
                res.put("data",result.toString());

                listener.onSuccess(res); 
            }else{
                listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR, new Exception("Error request responseCode:"+response.getStatusLine().getStatusCode()));
            }


        } catch (HttpResponseException ht){
            listener.onError(E_HTTP_ERROR,String.valueOf(ht.getStatusCode()),ht);
        } catch (MalformedURLException mue){
            listener.onError(E_HOST_ERROR,E_HTTP_ERROR,mue);
        } catch (UnknownHostException ht){
            listener.onError(E_HOST_ERROR,E_HTTP_ERROR,ht);
        } catch (Exception e) {
            // Return real error
            Log.e("ApiWMC/post","error",e);
            listener.onError(E_REQUEST_ERROR,E_REQUEST_ERROR,e);
        }
    }

    /**
     * Método que crea un objecto de tipo HttpClient configurando un proxy
     * @param sesion objecto con información del proxy
     * @return
     */
    private static DefaultHttpClient setupClient(Session sesion) throws MalformedURLException, UnknownHostException {
        //configuracion de cliente con Proxy
        InetAddress address = InetAddress.getByName(new URL(sesion.getURL()).getHost());

        DefaultHttpClient httpclient = new DefaultHttpClient();
        //settea usuario y contraseña
        httpclient.getCredentialsProvider().setCredentials(
                new AuthScope(address.getHostAddress(), sesion.getPort()),
                new UsernamePasswordCredentials(sesion.getUsername(), sesion.getPassword()));

        HttpHost proxy = new HttpHost(address.getHostAddress(),  sesion.getPort());

        httpclient.getParams().setParameter(ConnRoutePNames.DEFAULT_PROXY, proxy);
        return httpclient;
    }

    /**
     * Método que proporciona la información de mcc, mnc y unique del la sim del dispositivo.
     * @param context
     */
    private static void getInfoSim(Context context){
        if (ActivityCompat.checkSelfPermission(context, Manifest.permission.READ_PHONE_STATE) != PackageManager.PERMISSION_GRANTED) {
            return;
        }

        // obtención de informacion de sim del dispositivo
        TelephonyManager tel = (TelephonyManager) context.getSystemService(context.TELEPHONY_SERVICE);
        String networkOperator = tel.getSimOperator(); 



        SessionManager sessionManager = new SessionManager(context); 

        String uniqueID = sessionManager.getUUID();
        if(uniqueID.isEmpty()){
            uniqueID = UUID.randomUUID().toString(); 
            
            sessionManager.setUUID(uniqueID);
        }  
        Log.e("UIIOD",uniqueID); 
        unique = uniqueID;
        if (!TextUtils.isEmpty(networkOperator)) {
            mcc = networkOperator.substring(0, 3);
            mnc = networkOperator.substring(3);
        }
        network_type = Utils.getNetwork(context);
    }

    /**
     *
     * Método que obtiene el medio por el cual esta conectado el dispositivo
     * @param context
     * @return Wifi o Mobile
     */
    private static String getTransport(Context context){
       final ConnectivityManager cm = (ConnectivityManager)context.getSystemService(Context.CONNECTIVITY_SERVICE);

        if (cm != null) {
            if (Build.VERSION.SDK_INT < 23) {
                final NetworkInfo ni = cm.getActiveNetworkInfo();

                if (ni != null) {

                    if (ni.isConnected() && (ni.getType() == ConnectivityManager.TYPE_WIFI)){
                        return "wifi";
                    }else{
                        return "mobile";
                    }
                }
            } else {
                final Network n = cm.getActiveNetwork();

                if (n != null) {
                    final NetworkCapabilities nc = cm.getNetworkCapabilities(n);

                    if (nc.hasTransport(NetworkCapabilities.TRANSPORT_WIFI)){
                        return "wifi";
                    }else{
                        return "mobile";
                    }
                }
            }
        }
        return "wifi";
    }

    private static void setDetailDevice(){ //detalle de dispositivo
        device_name = DeviceName.getDeviceName(); //nombre de dispositovo
        device_os = Utils.currentVersion(); // version del sistema operativo
        appid = BuildConfig.APPLICATION_ID; // appid de la aplicación
        app_Version = BuildConfig.VERSION_NAME; // versión de la aplicación
        language = Locale.getDefault().getLanguage();
    }
}
